/*
 * Hedgewars, a worms-like game
 * Copyright (c) 2005 Andrey Korotaev <unC0Rr@gmail.com>
 *
 * Distributed under the terms of the BSD-modified licence:
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * with the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef BINDS_H
#define BINDS_H

#include <QtGlobal>

#define BINDS_NUMBER 18

struct BindAction
{
	QString action;
	QString strbind;
	QString name;
	bool chwidget;
};

const BindAction cbinds[BINDS_NUMBER] =
{
	{"+up",	"up",	QT_TR_NOOP("up"),	false},
	{"+left",	"left",	QT_TR_NOOP("left"),	false},
	{"+right",	"right",	QT_TR_NOOP("right"),	false},
	{"+down",	"down",	QT_TR_NOOP("down"),	false},
	{"ljump",	"return",	QT_TR_NOOP("jump"),	false},
	{"hjump",	"backspace",	QT_TR_NOOP("jump"),	false},
	{"+attack",	"space",	QT_TR_NOOP("attack"),	false},
	{"switch",	"tab",	QT_TR_NOOP("switch"),	true},
	{"slot 1",	"f1",	QT_TR_NOOP("slot 1"),	false},
	{"slot 2",	"f2",	QT_TR_NOOP("slot 2"),	false},
	{"slot 3",	"f3",	QT_TR_NOOP("slot 3"),	false},
	{"slot 4",	"f4",	QT_TR_NOOP("slot 4"),	false},
	{"slot 5",	"f5",	QT_TR_NOOP("slot 5"),	false},
	{"slot 6",	"f6",	QT_TR_NOOP("slot 6"),	false},
	{"slot 7",	"f7",	QT_TR_NOOP("slot 7"),	false},
	{"slot 8",	"f8",	QT_TR_NOOP("slot 8"),	true},
	{"capture",	"f11",	QT_TR_NOOP("capture"),	false},
	{"quit",	"f10",	QT_TR_NOOP("quit"),	false}
};

#endif // BINDS_H
